local LibSimpleOptions = LibStub("LibSimpleOptions-1.0")

local function Options(self, anchor)
	local title, subText = self:MakeTitleTextAndSubText(SQUIDFRAME_NAME, SQUIDFRAME_SUBTEXT)

	local SquidFrameDropDown = self:MakeDropDown(
	'name', SQUIDFRAME_FRAME_DROPDOWN_NAME,
	'description', SQUIDFRAME_FRAME_DROPDOWN_DESCRIPTION,
	'values', {
	'none', SQUIDFRAME_NONE,
	'rare', SQUIDFRAME_RARE,
	'rareelite', SQUIDFRAME_RARE_ELITE,
	'elite', SQUIDFRAME_ELITE,
	'rarepixel', "Rare (Pixel)",
	'elitepixel', "Elite (Pixel)",
	'blizzcon1', "BlizzCon '07 1",
	'blizzcon2', "BlizzCon '07 2",
	'deathknight1', "Deathknight 1",
	'deathknight2', "Deathknight 2",
	'rogue1', "Rogue 1",
	'squid', "SquidFrame",
	-- add skin name below --
	},
	'default', 'squid',
	'getFunc', function() return SquidFrameConfig.Portrait end,
	'setFunc', 
	function(value) SquidFrameConfig.Portrait = value
	SquidFrame_OnPortraitChange() end
	
	)
	
	local SquidFrameCheckBox = self:MakeToggle(
	'name', SQUIDFRAME_ADJUST_CHECKBOX_NAME,
	'description', SQUIDFRAME_ADJUST_CHECKBOX_DESCRIPTION,
	'default', false,
	'getFunc', function() return SquidFrameConfig.Adjust end,
	'setFunc', 
	function(value) SquidFrameConfig.Adjust = value
	SquidFrame_Adjust() end
	
	)
	
SquidFrameDropDown:SetPoint("TOPLEFT", subText, "BOTTOMLEFT", -15, -30)
SquidFrameCheckBox:SetPoint("TOPLEFT", subText, "BOTTOMLEFT", 0, -60)
end

function SquidFrame_OnPortraitChange()
	if SquidFrameConfig.Portrait == "none" then
		PlayerFrameTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame.blp"); 
		PlayerFrameTexture:SetPoint("TOPLEFT", 0, 0); end
	if SquidFrameConfig.Portrait == "rare" then
		PlayerFrameTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Rare.blp"); 
		PlayerFrameTexture:SetPoint("TOPLEFT", 0, 0); end
	if SquidFrameConfig.Portrait == "rareelite" then
		PlayerFrameTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Rare-Elite.blp"); 
		PlayerFrameTexture:SetPoint("TOPLEFT", 0, 0); end
	if SquidFrameConfig.Portrait == "elite" then
		PlayerFrameTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Elite.blp"); 
		PlayerFrameTexture:SetPoint("TOPLEFT", 0, 0); end
	if SquidFrameConfig.Portrait == "rarepixel" then				
		PlayerFrameTexture:SetTexture("Interface\\AddOns\\SquidFrame\\textures\\rarepixel.tga")
		PlayerFrameTexture:SetPoint("TOPLEFT", 0, 0); end
	if SquidFrameConfig.Portrait == "elitepixel" then				
		PlayerFrameTexture:SetTexture("Interface\\AddOns\\SquidFrame\\textures\\elitepixel.tga")
		PlayerFrameTexture:SetPoint("TOPLEFT", 0, 0); end
	if SquidFrameConfig.Portrait == "blizzcon1" then
		PlayerFrameTexture:SetTexture("Interface\\AddOns\\SquidFrame\\textures\\blizzcon1.tga"); 
		PlayerFrameTexture:ClearAllPoints(); 
		PlayerFrameTexture:SetPoint("TOPLEFT", 0, 0);
		PlayerFrameTexture:SetTexCoord(1, 0, 0, 1);
		end
	if SquidFrameConfig.Portrait == "blizzcon2" then
		PlayerFrameTexture:SetTexture("Interface\\AddOns\\SquidFrame\\textures\\blizzcon2.tga"); 
		PlayerFrameTexture:ClearAllPoints();
		PlayerFrameTexture:SetPoint("TOPLEFT", 3, 7);
		PlayerFrameTexture:SetTexCoord(1, 0, 0, 1);
		end
	if SquidFrameConfig.Portrait == "deathknight1" then
		PlayerFrameTexture:SetTexture("Interface\\AddOns\\SquidFrame\\textures\\deathknight1.tga"); 
		PlayerFrameTexture:ClearAllPoints(); 
		PlayerFrameTexture:SetPoint("TOPLEFT", 0, 0);
		PlayerFrameTexture:SetTexCoord(1, 0, 0, 1);
		end
	if SquidFrameConfig.Portrait == "deathknight2" then
		PlayerFrameTexture:SetTexture("Interface\\AddOns\\SquidFrame\\textures\\deathknight2.tga"); 
		PlayerFrameTexture:ClearAllPoints();
		PlayerFrameTexture:SetPoint("TOPLEFT", 0, 0);
		PlayerFrameTexture:SetTexCoord(1, 0, 0, 1);
		end
	if SquidFrameConfig.Portrait == "rogue1" then
		PlayerFrameTexture:SetTexture("Interface\\AddOns\\Squidframe\\textures\\rogue1.tga");
		PlayerFrameTexture:ClearAllPoints();
		PlayerFrameTexture:SetPoint("TOPLEFT", 3, 7);
		PlayerFrameTexture:SetTexCoord(1, 0, 0, 1);
		end
	if SquidFrameConfig.Portrait == "squid" then
		PlayerFrameTexture:SetTexture("Interface\\AddOns\\SquidFrame\\textures\\squid.tga");
		PlayerFrameTexture:ClearAllPoints();
		PlayerFrameTexture:SetPoint("TOPLEFT", 5, 17);
		PlayerFrameTexture:SetTexCoord(1, 0, 0, 1);
		end
	-- add skin texture below --	
end

function SquidFrame_Adjust()
	if SquidFrameConfig.Adjust == true then PlayerFrame:SetPoint("TOPLEFT", 0, -4); else PlayerFrame:SetPoint("TOPLEFT", -19, -4); end
end

local function OnEvent(self, name)
	if (SquidFrameConfig == nil) then
		SquidFrameConfig = { };
		SquidFrameConfig.Portrait = 'elite';
		SquidFrameConfig.Adjust = false;
	end
	SquidFrame_OnPortraitChange();
	SquidFrame_Adjust();
	LibSimpleOptions.AddOptionsPanel("SquidFrame", function(self) Options(self, anchor) end)
	LibSimpleOptions.AddSlashCommand("SquidFrame", "/squidframe")
	self:UnregisterEvent("ADDON_LOADED")
end

local event = CreateFrame("Frame")
event:RegisterEvent("ADDON_LOADED") 
event:SetScript("OnEvent", function(self, event, ...) OnEvent(self, ...) end)