local colWhite = "|cFFFFFFFF" -- White
local colPurple = "|cFF8880FF" -- White  	
local colLBlue = "|cFF82CAFF" -- White

Squid_Frame = {}
Squid_Frame.Title = "SquidFrame ";
Squid_Frame.events = {}

Squid_Frame.eventFrame = CreateFrame("Frame")
Squid_Frame.eventFrame:SetScript("OnEvent", function(this, event, ...)
  Squid_Frame.events[event](...)
end)
Squid_Frame.eventFrame:RegisterEvent("CHAT_MSG_SYSTEM");
Squid_Frame.eventFrame:RegisterEvent("PLAYER_LOGIN")
Squid_Frame.eventFrame:RegisterEvent("ADDON_LOADED")

function Squid_Frame.events.ADDON_LOADED(addon)
    if addon ~= "SquidFrame" then
        return
    end

    -- Default Profile
    if (not Squid_FrameData) then 
        Squid_FrameData = { };
          Squid_FrameData.config = { };
	  Squid_FrameData.config.HB = true;
	  Squid_FrameData.config.BG = true;
	  Squid_FrameData.config.CBG = false;			
    end    

    -- Interface - Options
    Squid_Frame:CreateOptionFrame()
    
    -- Slash Options
    SlashCmdList["Squid_Frame"] = Squid_Frame.Options
    SLASH_Squid_Frame1 = "/SquidFrame2"
    SLASH_Squid_Frame2 = "/SF2"    
end

function Squid_Frame.events.PLAYER_LOGIN()
    hooksecurefunc("SetPortraitTexture",Port.newSetPortraitTexture)
    if Squid_FrameData.config.HB then
       
hooksecurefunc("HealthBar_OnValueChanged", Squid_Frame.HealthBar_OnValueChanged)
    end
    UIErrorsFrame:AddMessage(colPurple .. Squid_Frame.Title .. "|r " .. colPink .. Squid_Frame.Version .. "|r" .. colWhite .. " loaded.|r")
    DEFAULT_CHAT_FRAME:AddMessage(colPurple .. Squid_Frame.Title .. "|r " .. colPink .. Squid_Frame.Version .. "|r" .. colWhite .. " loaded.|r")
end

function Squid_Frame.events.CHAT_MSG_SYSTEM()
    Squid_Frame_SystemMessages();
end

function Squid_Frame_SystemMessages()
--------------------------------
--- Show AFK/DND in Namebox  ---
--------------------------------
   if (arg1 == CLEARED_AFK) then 
       PlayerName:SetText(UnitName("player"));
   elseif (arg1 == CLEARED_DND) then
       PlayerName:SetText(UnitName("player"));
   elseif string.find(arg1, "You are now AFK") then
       PlayerName:SetText("<AFK> "..UnitName("player"));
   elseif string.find(arg1, "You are now DND") then
       PlayerName:SetText("<DND> "..UnitName("player"));
   end
end

--------------------------------
---  Heath Bar Status Color  ---
--------------------------------

function Squid_Frame.HealthBar_OnValueChanged(self, value)

    if (not value) then

        return;

    end

    
    local r, g, b
	
    local min, max = self:GetMinMaxValues()


    if ( (value < min) or (value > max) ) then

        return;

    end


    if ( (max - min) > 0 ) then
        value = (value - min) / (max - min)

    else

        value = 0;

    end

    if (value > 0.5) then

        r = (1.0 - value) * 2

        g = 1.0

    else

        r = 1.0;

        g = value * 2

    end


    b = 0.0


    self:SetStatusBarColor(r, g, b)


end



---------------------------------
------  Animated Portrait  ------
---------------------------------

Port = {
	Textures = {}, -- table of textures models are replacing
	xOffset = -0.8, -- x offset of model
	yOffset = -2, -- y offset of model
	StrataByIndex = { "BACKGROUND","LOW","MEDIUM","HIGH","TOOLTIP" }, -- for strata guessing
	StrataByName = { ["BACKGROUND"]=1, ["LOW"]=2, ["MEDIUM"]=3, ["HIGH"]=4, ["TOOLTIP"]=5 },
        target = TargetPortrait
       }


Port_Settings = {
		   Use = { ["PlayerPortrait"]=1, ["PetPortrait"]=2, ["TargetPortrait"]=3, ["TargetsTargetPortrait"]=4, ["PartyMemberFrame1Portrait"]=5, ["PartyMemberFrame2Portrait"]=6, ["PartyMemberFrame3Portrait"]=7, ["PartyMemberFrame4Portrait"]=8 }
	        }
  
        function Port.newSetPortraitTexture(texture,unit)
        local swapHappened = nil -- whether a texture was swapped with a model
   
        if texture and texture.GetLeft then

		local textureName = texture:GetName()
		local xpos = texture:GetLeft()
		local ypos = texture:GetTop()

		if textureName and xpos and ypos and UnitExists(unit) and Port_Settings.Use[textureName]then

			if(UnitIsVisible(unit)) then
				local width=texture:GetRight()-xpos
				local height=ypos-texture:GetBottom()
				if width>24 and height>24 then

					if not Port.Textures[textureName] then
						Port.CreateModel(texture)
					end
					local m = Port.Textures[textureName].modelLayer
					-- m = CharacterModelFrame
					m:SetUnit(unit)
					m:SetCamera(0)

					_,Port.Textures[textureName].class = UnitClass(unit)
                                        if Squid_FrameData.config.CBG then
                                           Port.ColorBackground(textureName,Port.Textures[textureName].class)
					end
                                        texture:Hide()

					Port.Textures[textureName]:Show()

					m:Show()

					swapHappened = 1
				end

			else
				if (textureName and Port.Textures[textureName]) then
					Port.Textures[textureName].modelLayer:Hide()
				end
			end

		end
	end

	if not swapHappened then
--		Port.oldSetPortraitTexture(texture,unit)
		texture:Show()
		if textureName and Port.Textures[textureName] then
			Port.Textures[textureName]:Hide()
		end
	end
end

function Port.CreateModel(texture)
	local textureName = texture:GetName()
	local width = texture:GetWidth()
	local height = texture:GetHeight()
	if texture.GetParent and texture:GetParent().GetFrameStrata and texture:GetParent():GetFrameStrata()=="BACKGROUND" then
		texture:GetParent():SetFrameStrata("Low")
	end
	local modelName = textureName.."Model"
	Port.Textures[textureName] = CreateFrame("Button",modelName,texture:GetParent())
	local frame = Port.Textures[textureName]
	frame:EnableMouse(0)
	frame:SetWidth(width)
	frame:SetHeight(height)
	frame.width = width
	frame.height = height
	frame:SetPoint("CENTER",texture,"CENTER",0,0)
	local strata
	if texture.GetParent then
		strata = Port.StrataByIndex[(Port.StrataByName[texture:GetParent():GetFrameStrata() or ""] or 1)-1]
	end
        frame:SetFrameStrata(strata or "BACKGROUND")
	frame.backLayer = frame:CreateTexture(modelName.."Back","BACKGROUND")
	
        if Squid_FrameData.config.CBG then
           frame.backLayer:SetTexture("Interface\\AddOns\\SquidFrame\\skin\\ClassBack")
        else
	   frame.backLayer:SetTexture("Interface\\AddOns\\SquidFrame\\skin\\ModelBack")
        end

	frame.backLayer:SetWidth(width)
	frame.backLayer:SetHeight(height)
	frame.backLayer:SetPoint("CENTER",frame,"CENTER",0,0)
        
        if Squid_FrameData.config.BG then
	   frame.backLayer:Show()
        else
           frame.backLayer:Hide()
	end

        frame.modelLayer = CreateFrame("PlayerModel",modelName.."Model",texture:GetParent())
	frame.modelLayer:SetPoint("CENTER",frame,"CENTER",0,0)
	frame.modelLayer:SetFrameLevel(1)
	frame.modelLayer:SetScript("OnShow",function(self) self:SetCamera(0) end)
	Port.Shape(textureName)
	frame.modelLayer.timer = 0
end

function Port.ColorBackground(textureName,class)
	local back = Port.Textures[textureName].backLayer
	local color = RAID_CLASS_COLORS[class or ""]
	if color then
		back:SetVertexColor(color.r/1.5,color.g/1.5,color.b/1.5,1)
	else
		back:SetVertexColor(5,.5,.5,1)
	end
end

function Port.Shape(i)
	if not i or type(i)~="string" or not Port.Textures[i] then
		return
	end
        local back = Port.Textures[i].backLayer
        local model = Port.Textures[i].modelLayer
	local texture = getglobal(i)
	if texture then
		width = texture:GetWidth()
		height = texture:GetHeight()
	else
		width = Port.Textures[i].width
		height = Port.Textures[i].height
	end
	model:ClearAllPoints()
	model:SetPoint("CENTER",i,"CENTER",Port.xOffset,Port.yOffset)
	model:SetWidth(width*.80)
	model:SetHeight(height*.80)
end
